package cl.mc3d;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Graphics;

import java.awt.Graphics2D;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;

import java.io.*;

import java.net.URL;

import javax.imageio.ImageIO;

import javax.swing.*;

class MiIFrame extends JInternalFrame
  implements Runnable
{
  Thread Hilo=null;
  BufferedImage buf=null;
  JPanel jpCanvas=null;
  String id=null;
  public int ancho=0;
  public int alto=0;
  String Servidor=null;
  public MiIFrame(String id)
  {
    this.id=id;
    this.setTitle("Session id:"+id);
    this.setBounds(0,0,600,450);
    this.setMaximizable(true);
    this.setResizable(true);
    this.setIconifiable(true);
    this.setClosable(true);
    JPanel jpVisor=jpPrincipal();
    JScrollPane jsVisor=new JScrollPane(jpVisor);
    jpVisor.setPreferredSize(new Dimension(2000,2000));
    this.add(jsVisor);
    Servidor=""+System.getProperty("servidor");
	    if(Servidor.length()<5)
	    {
	    Servidor="http://127.0.0.1:8988/miemp-MyWebConferenceServer-context-root";
	    }     
    start();    
    this.setVisible(true);  
  }

  public void start()
  {
    if(Hilo==null)
    {
      Hilo=new Thread(this);
    }
    Hilo.start();
  }

  public void run()
  {
    while(true)
    {
      try
      {
	if(buf!=null)
	{
	  buf.flush();
	}
	buf=
	ImageIO.read(new URL(Servidor+"/vista.do?id="+id));
	jpCanvas.repaint();
	Hilo.sleep(5000);
      }
      catch(InterruptedException e)
      {
	System.out.println(e.toString());
      }
      catch(Exception e)
      {
	System.out.println(e.toString());
      }
      if(!this.isVisible())
      {
	break;
      }
    }
  }

  public JPanel jpPrincipal()
  {
    jpCanvas=new JPanel()
	{
	  public void paintComponent(Graphics g)
	  {
	    super.paintComponent(g);
	    Graphics2D g2=(Graphics2D)g;
	    try
	    {
	      if(buf!=null)
	      {
		int ancho=buf.getWidth();
		int alto=buf.getHeight();
		super.setSize(ancho,alto);
		g2.drawImage(buf,0,0,this);
	      }
	    }
	    catch(Exception e)
	    {
	      System.out.println(e.toString());
	    }
	  }
	};
    return jpCanvas;
  }
}
class XMLVisor
  extends JFrame
  implements Runnable
{
  Thread Hilo=null;
  JDesktopPane jdpPrincipal;
  JMenuBar jmbPrincipal;
  public XMLVisor()
  {
    setTitle("MyWebConference");
    setSize(800,600);
    jdpPrincipal=new JDesktopPane();
    jmbPrincipal=new JMenuBar();
    JMenu jmFile=new JMenu("File");
    JMenuItem jmiOpen=new JMenuItem("New session");
    jmiOpen.addActionListener(new ActionListener()
	{
	  public void actionPerformed(ActionEvent evt)
	  {
	  JOptionPane jop=new JOptionPane();
	  jop.updateUI();
	    String id= jop.showInputDialog("Key of conference");
	    if(id!=null)
	    {
	      if(id.length()>0)
	      {
	      MiIFrame miCanvas=new MiIFrame(id);
	      jdpPrincipal.add("Center",miCanvas);
	      }
	    }
	  }
	});
    jmFile.add(jmiOpen);
    JMenuItem jmiExit=new JMenuItem("Exit");
    jmFile.add(jmiExit);
    jmbPrincipal.add(jmFile);
    setJMenuBar(jmbPrincipal);
    getContentPane().add("Center",jdpPrincipal);
    setVisible(true);
    setDefaultCloseOperation(3);
    start();
  }

  public void start()
  {
    if(Hilo==null)
    {
      Hilo=new Thread(this);
    }
    Hilo.start();
  }

  public void run()
  {
    while(true)
    {
      try
      {
	jdpPrincipal.repaint();
	jmbPrincipal.repaint();
	this.repaint();
	Hilo.sleep(50);
      }
      catch(InterruptedException e)
      {
	System.out.println(e.toString());
      }
      if(!this.isVisible())
      {
	System.exit(0);
      }
    }
  }

  public static void main(String[] args)
  {
    new XMLVisor();
  }
}
